#version 330 core
#extension GL_EXT_geometry_shader4 : enable


layout(points) in;
layout(points, max_vertices = 30) out;

uniform float timeDiff;
uniform int turn;

in float[] typeGS;                                                                    
in vec3[] positionGS;                                                                 
in vec3[] movementGS;                                                                 
in float[] lifetimeLeftGS;  

out float type;
out vec3 position;
out vec3 movement;
out float lifetimeLeft;


void main() {
	for(int i = 0; i < gl_VerticesIn; i++) {
	
		if(typeGS[i] == 1.0f){
			for(int i = 0; i < 32; i++){
				type = 2.0f;
				position = positionGS[0];
					if(i == 0){
						movement = vec3(0.7f,0.7f,0.7f);
					}else if (i == 1){
						movement = vec3(-0.7f,0.7f,0.7f);
					}else if (i == 2){
						movement = vec3(0.7f,0.7f,-0.7f);
					}else if (i == 3){
						movement = vec3(-0.7f,0.0f,-0.7f);
					}else if (i == 4){
						movement = vec3(0.7f,0.0f,0.7f);
					}else if(i == 5){
						movement = vec3(0.0f,0.7f,0.0f);
					}else if (i == 6){
						movement = vec3(0.0f,0.0f,-0.7f);
					}else if (i == 7){
						movement = vec3(-0.7f,0.0f,0.0f);
					}else if (i == 8){
						movement = vec3(0.0f,0.0f,0.7f);
					}else if (i == 9){
						movement = vec3(0.7f,0.0f,0.0f);
					}else if(i == 10){
						movement = vec3(0.0f,-0.7f,0.0f);
					}else if (i == 11){
						movement = vec3(-0.7f,-0.7f,-0.7f);
					}else if (i == 12){
						movement = vec3(-0.7f,-0.7f,0.7f);
					}else if (i == 13){
						movement = vec3(0.0f,-0.7f,-0.7f);
					}else if (i == 14){
						movement = vec3(0.0f,0.7f,0.7f);
					}else if (i == 15){
						movement = vec3(0.7, -0.7, 0.0f);
					}else if(i == 16){
						movement = vec3(0.7f,0.7f,0.7f) * timeDiff +1;
					}else if (i == 17){
						movement = vec3(-0.7f,0.7f,0.7f) * timeDiff +1;
					}else if (i == 18){
						movement = vec3(0.7f,0.7f,-0.7f) * timeDiff +1;
					}else if (i == 19){
						movement = vec3(-0.7f,0.0f,-0.7f) * timeDiff +1;
					}else if (i == 20){
						movement = vec3(0.7f,0.0f,0.7f) * timeDiff +1;
					}else if(i == 21){
						movement = vec3(0.0f,0.7f,0.0f) * timeDiff +1;
					}else if (i == 22){
						movement = vec3(0.0f,0.0f,-0.7f) * timeDiff +1;
					}else if (i == 23){
						movement = vec3(-0.7f,0.0f,0.0f) * timeDiff +1;
					}else if (i == 24){
						movement = vec3(0.0f,0.0f,0.7f) * timeDiff +1;
					}else if (i == 25){
						movement = vec3(0.7f,0.0f,0.0f) * timeDiff +1;
					}else if(i == 26){
						movement = vec3(0.0f,-0.7f,0.0f) * timeDiff +1;
					}else if (i == 27){
						movement = vec3(-0.7f,-0.7f,-0.7f) * timeDiff +1;
					}else if (i == 28){
						movement = vec3(-0.7f,-0.7f,0.7f) * timeDiff +1;
					}else if (i == 29){
						movement = vec3(0.0f,-0.7f,-0.7f) * timeDiff +1;
					}else if (i == 30){
						movement = vec3(0.0f,0.7f,0.7f) * timeDiff +1;
					}else if (i == 31){
						movement = vec3(0.7, -0.7, 0.0f) * timeDiff +1;
					}
				lifetimeLeft = 1.0f;
				EmitVertex();
				EndPrimitive();
			}
		}else if(typeGS[i] == 2.0f){
			lifetimeLeft = lifetimeLeftGS[i] + timeDiff;
			type = typeGS[i];
			movement = movementGS[i];
			position = positionGS[i] + movement * timeDiff;
			EmitVertex();
			EndPrimitive();
			
		}
	}

}
