#version 330 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 base;

uniform mat4 view;
uniform mat4 projection;

void main(){	
	//*0.09 is a scale factor; change if necessary
	vec3 newposition = position.xyz + base.xyz * 0.09;
	gl_Position = projection * view * vec4(newposition, 1.0f);

}

