#version 330 core

vec4 celshade(in float intensity, in vec4 color) {
	//vec4 color;
	if (intensity > 0.98)
		color = vec4(0.8,0.8,0.8,1.0);
	else if (intensity > 0.5)
		color = vec4(0.4,0.4,0.8,1.0);
	else if (intensity > 0.25)
		color = vec4(0.2,0.2,0.4,1.0);
	else
		color = vec4(0.1,0.1,0.1,1.0);
	return(color);
}

//return a band of lighting intensity to multiply with colors
vec3 celshade(in float intensity)
{
	vec3 color;

	if (intensity > 0.98)
		color = vec3(0.8,0.8,0.8);
	else if (intensity > 0.5)
		color = vec3(0.4,0.4,0.8);
	else if (intensity > 0.25)
		color = vec3(0.2,0.2,0.4);
	else
		color = vec3(0.1,0.1,0.1);
	return(color);
}

float intensityCel(in float intensity)
{

	float ret;
	if (intensity > 0.98)
		ret =  0.8;
	else if (intensity > 0.5)
		ret =  0.4;
	else if (intensity > 0.25)
		ret =  0.2;
	else
		ret =  0.1;
	return ret;
}